<template>
<div class="analytics-home">
  <div class="grid grid-cols-3 gap-10 p-2">
    <div>
      <q-select
          v-model="selectedAnalytics"
          :model-value="selectedAnalytics?.label || 'Выбрать'"
          outlined
          dense
          options-dense
          emit-value
          map-options
          :options="options"
      >
        <template v-slot:option="{ itemProps, opt, selected, toggleOption }">
          <q-item v-bind="itemProps">
            <q-item-section :model-value="selected" @update:model-value="toggleOption(opt)">
              <q-item-label v-html="opt.label" />
            </q-item-section>
          </q-item>
        </template>
      </q-select>
    </div>
    <div>
      <q-chip :label="selectedTime?.from && `${selectedTime.from} - ${selectedTime.to}` || selectedTime || 'Выбрать период'" class="cursor-pointer">
        <q-menu>
          <q-date range :locale="myLocale" :model-value="new Date()" v-model="selectedTime" color="info" />
        </q-menu>
      </q-chip>
      <q-chip v-if="selectedAnalytics?.id === 1" label="Статусы" class="cursor-pointer">
        <q-menu>
          <q-item v-for="s in status" class="flex items-center">
            {{s.name}}

            <q-toggle v-model="s.toggle" :model-value="s.toggle" class="ml-auto" />
          </q-item>
        </q-menu>
        <q-tooltip>
          Вы можете выбирать статусы, на основе которых делается аналитика<br>
          Некоторые статусы по умолчанию выключены
        </q-tooltip>
      </q-chip>
    </div>
    <div>
      <q-btn @click="getAnalytics" :loading="loading" label="Загрузить" push rounded class="main-bg-black text-white" :disable="selectedAnalytics || !!!selectedTime || !!!selectedAnalytics"/>
    </div>
  </div>
  <div v-if="selectedAnalytics && selectedAnalytics.id === 4" class="ml-10 mt-10 overflow-hidden pb-14">
    <Dept v-if="selectedTime?.from && isDeptBlock" @selectUser="selectUser" :date="selectedTime" :exception="status.map(el => !el.toggle && el.name).filter(s => s)" />
    <div v-else class="italic text-xl text-gray-600">Выберите период и нажмите "Загрузить"</div>
  </div>
  <q-slide-transition>
    <q-table
        v-show="rows.length"
        flat bordered
        title="Аналитика"
        :rows="rows"
        :columns="columns"
        separator="vertical"
        row-key="name"
        :rows-per-page-options="[0]"
        class="my-table"
    >
      <template v-slot:bottom="props">
        <div class="grid grid-cols-2 w-full">
          <div></div>
          <div v-if="total > 0" class="ml-auto text-h5">Всего: <q-badge :label="total" color="grey" class="text-h5"/></div>
        </div>
      </template>
    </q-table>
  </q-slide-transition>
</div>
</template>

<script>
import {computed, onMounted, ref} from "vue";
import {date} from "quasar";
import api from '../../API/analytics'
import apiMain from '../../API/api'
import Dept from "./Dept.vue";

export default {
  name: "index",
  components: {Dept},
  setup () {
    const loading = ref(false)
    const loadingStatus = ref(false)
    const selectedAnalytics = ref(null)
    const selectedTime = ref(null)
    const status = ref([])
    const isDeptBlock = ref(false)

    const options = [
      {label: 'Передано в регион', id: 0}, // поиск лидов со статусом передано в регион
      {label: 'Все лиды', id: 1}, // все лиды от лидогенераторов
      {label: 'Статьи', id: 2}, // лиды с доп поля "СтатьяКоАП"
      {label: 'Регионы', id: 3}, // поиск лидов у которых указан город
      {label: 'Финансы отделов', id: 4}, // поиск лидов у которых указан город
    ]

    const tempObj = {
      name: 'article',
      label: 'Статьи',
      align: 'left',
      field: 'article',
      format: val => `${val}`,
      sortable: false
    }


    const columns = ref([
      {
        name: 'name',
        label: computed(() => selectedAnalytics.value?.id === 1 && 'Источник' || selectedAnalytics.value?.id === 2 && 'Статья' || 'Город'),
        align: 'left',
        field: 'name',
      },
      tempObj,
      {
        name: 'total',
        label: 'Количество',
        align: 'left',
        field: 'total',
        format: val => `${val}`,
        sortable: true
      }
    ])
    const rows = ref([])
    const total = ref(0)

    const today = date.formatDate(new Date(), 'DD/MM/YYYY')

    const selectedUser = ref(null)
    const summa = ref(null)
    function selectUser(val) {
      summa.value = null
      selectedUser.value = val
    }

    async function getAnalytics () {
      isDeptBlock.value = false
      if (selectedAnalytics.value.id === 1 && columns.value[1].field !== 'article') columns.value.splice(1,0, tempObj)
      if (selectedAnalytics.value.id !== 1) columns.value.splice(1,1)
      if (selectedAnalytics.value.id === 4) {
        isDeptBlock.value = true
        return false
      }

      loading.value = true
      try {
        let date
        const exception = status.value.map(el => !el.toggle && el.name).filter(s => s)
        if (typeof selectedTime.value === 'string') date = {from: null, to: selectedTime.value, id: selectedAnalytics.value.id, exception}
        else date = {from: selectedTime.value.from, to: selectedTime.value.to, id: selectedAnalytics.value.id, exception, _id: selectedUser.value || null}
        const response = await api.getAnalytics(date)
        if(selectedUser.value) return summa.value += response.data.summa
        total.value = response.data.total
        if (rows.value.length) rows.value = response.data.label
        else rows.value.push(...response.data.label)
      }
      catch (err) {}
      finally {
        loading.value = false
      }
    }
    async function getStatus () {
      loadingStatus.value = true
      try {
        const response = await apiMain.getStatusLeads()
        status.value = response.data.statusLeads.filter(el => el.toggle = true)
        status.value.forEach(el => {
          const arr = [
              '6453586b5c38329032d0f2dc', // дубль
              '645356585c38329032d0f2da', // отказ
              '64535d1c5c38329032d0f2e1', // отказ Т
              '6452986e5c38329032d0f2d1', // Спам/Не оставлял
          ]
          if (arr.includes(el._id)) el.toggle = false
        })
      }
      catch (err) {console.log(err)}
      finally {
        loadingStatus.value = false
      }
    }

    onMounted(() => {
      getStatus()
    })

    return {
      loading,
      columns,
      rows,
      total,
      selectedAnalytics,
      selectedTime,
      today,
      status,

      selectUser, selectedUser,summa,

      getAnalytics,
      isDeptBlock,

      options,
      pagination: { rowsPerPage: 0 },
      myLocale: {
        /* starting with Sunday */
        days: 'Воскресенье_Понедельник_Вторник_Среда_Четверг_Пятница_Суббота'.split('_'),
        daysShort: 'Вс_Пн_Вт_Ср_Чт_Пт_Сб'.split('_'),
        months: 'Январь_Февраль_Март_Апрель_Май_Июнь_Июль_Август_Сентябрь_Октябрь_Ноябрь_Декабрь'.split('_'),
        monthsShort: 'Янв_Фев_Мар_Апр_Май_Июн_Июл_Авг_Сен_Окт_Ноя_Дек'.split('_'),
        firstDayOfWeek: 1, // 0-6, 0 - Sunday, 1 Monday, ...
        format24h: true,
      }
    }
  }
}
</script>

<style scoped lang="sass">
.my-table
  /* height or max-height is important */
  height: calc(100% - 120px)
  max-height: calc(100% - 120px)

  .q-table__top,
  .q-table__bottom,
  thead tr:first-child th
    /* bg color is important for th; just specify one */
    background-color: #00b4ff

  thead tr th
    position: sticky
    z-index: 1
  thead tr:first-child th
    top: 0

  /* this is when the loading indicator appears */
  &.q-table--loading thead tr:last-child th
    /* height of all previous header rows */
    top: 48px

  /* prevent scrolling behind sticky top row on focus */
  tbody
    /* height of all previous header rows */
    scroll-margin-top: 48px

</style>
